package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class InstructorTest {

    @Test
    public void testImplementation() {
        //Given
        Instructor instructor = new Instructor(1, "Name");
        //Then
        Assert.assertTrue(instructor instanceof Teacher);
    }

    @Test
    public void testInheritance() {
        //Given
        Instructor instructor = new Instructor(1, "Name");
        //Then
        Assert.assertTrue(instructor instanceof Person);

    }

    @Test
    public void testTeach() {
        //Given
        Student student = new Student(1, "Name");
        Instructor instructor = new Instructor(1, "Name");
        double expected = 1;
        //When
        instructor.teach(student, 1);
        double actual = student.getTotalStudyTime();
        //Then
        Assert.assertEquals(expected, actual, .001);

    }

    @Test
    public void testLecture() {
        //Given
        Instructor instructor = new Instructor(1, "Name");
        Student student1 = new Student();
        Student student2 = new Student();
        Student student3 = new Student();
        Student[] students = {student1, student2, student3};

        double amountOfTimeLectured = 15;
        double expected = amountOfTimeLectured / students.length;

        // When
        instructor.lecture(students, amountOfTimeLectured);
        //Then
        for (Student student : students) {
            Assert.assertEquals(expected, student.getTotalStudyTime(), .0);


        }


    }
}
